﻿using System;
using XGame.Framework.Asset;
using XGame.Framework.Quality;
using XGame.Framework.Time;

namespace XGame.Framework.Nodes
{
    public class NodeContext : IDisposable
    {
        public IAssetModule AssetModule { get; private set; }
        public IQualityModule QualityModule { get; private set; }
        public ITimeModule TimeModule { get; private set; }

        public NodeContext(IAssetModule assetModule, IQualityModule qualityModule, ITimeModule timeModule)
        {
            AssetModule = assetModule;
            QualityModule = qualityModule;
            TimeModule = timeModule;
        }

        void IDisposable.Dispose()
        {
            AssetModule = null;
            QualityModule = null;
            TimeModule = null;
            OnDispose();
        }
        protected virtual void OnDispose()
        {

        }
    }
}
